mod board;
mod game;

use anyhow::Result;
use engine::prelude::*;
use game::MillGame;

fn main() -> Result<()> {
    let mut create_info = EngineCreateInfo::default();
    create_info.resource_base_path = "".to_string();

    let engine = Engine::new(create_info)?;

    engine.set_game_object(Some(MillGame::new(engine.clone())?))?;

    engine.run()
}
